# core/plugs/uptime.py
#
#

""" uptime of services. """

## IMPORTS

from core.utils import str_day
from core import kernel

import time

## UNTIL

def until(obj): 
    if not obj.get("sleep"): return "0"
    return str_day(int(obj.sleep) - int(time.time() - obj._last))

def upt(obj):
    return str_day(int(time.time()) - int(obj._started))

## CMNDS

def uptime(event):
    for service in kernel.run:
        obj = kernel.run[service]
        event.reply("%s: %s/%s" % (service, upt(obj), until(obj)))

kernel.cmnds.register("uptime", uptime)