# core/rss.py
#
#

""" rss module. """

__copyright__ = "Copyright 2014 B.H.J Thate"

## IMPORTS

from core.utils import parse_urls, short_date, fetch_url, error
from core.object import Object

from core import kernel

## basic imports

import threading
import logging
import socket
import time

## RSS class

class RSS(Object):

    def __init__(zelf, sleep, *args, **kwargs):
        Object.__init__(zelf, *args, **kwargs)
        zelf._on_start = True
        zelf._status = "init"
        zelf._last = time.time()
        zelf._seen = []
        zelf.sleep = int(sleep)

    def exit(zelf, *args, **kwargs): zelf._timer.cancel()

    def start(zelf, *args, **kwargs):
        zelf._timer = threading.Timer(zelf.sleep, zelf.look)
        zelf._started = time.time()
        zelf._timer.start()

    def look(zelf, *args, **kwargs):
        import core.contrib.feedparser as fp
        zelf._status = "running"
        for obj in zelf.objects():
            if "rss" not in obj: continue
            zelf._last = time.time()
            logging.info("looking %s" % obj["rss"])
            zelf._status = "fetching"
            try: data = fetch_url("GET", obj.rss).read()
            except socket.error: continue
            try: data = fp.parse(data)
            except Exception as ex: error() ; continue
            for entry in data["entries"]:
                if entry["link"] in zelf._seen: continue
                else:
                    zelf._seen.append(entry["link"])
                    if not zelf._on_start: zelf.display(entry)
                    continue
            zelf._status = "running"
        zelf._on_start = False
        zelf.start()

    def display(zelf, *args, **kwargs):
        entry = args[0]
        result = "%s  %s" % (entry["title"], entry["link"])
        zelf.announce(result)

## INIT

def init(*args, **kwargs):
    rss = RSS(600.0)
    kernel.run.rss = rss
    kernel.workers.put(rss.start)
